<?php
/** Check files with the current directory (and child directories) for possible compatability issues with J3
*
* Not nearly as efficient as it could be, and will raise more false positives than I'd like, but it seemed better to err on the site of caution!
*
* @author: Ben Tasker
* @license: GNU GPL V2 - http://www.gnu.org/licenses/gpl-2.0.html
*
* Copyright (c) 2012 Ben Tasker - http://www.bentasker.co.uk, http://www.viryatechnologies.com
*
* Released as is, with NO WARRANTY
*
* It shouldn't trash your system, but please don't hold me responsible if it does! It doesn't, under normal circumstances, write to disk so the
* chances of damage should be small!
*
*/


// Get ready for a long array, and pity me for having had to type it! If I'd looked properly at the Joomla doc I may never have started this!
$strings = array(" DS ",".DS.","?no_html","JParameter","JElement","JFormFieldEditors","JHtmlImage","JRules","JSimpleXML","JPane","JFactory|getXMLParser",
"JFactory|_createConfig","JFactory|_createSession","JFactory|_createDbo","JFactory|_createMailer","JFactory|_createDocument",
"JApplicationHelper|getPath","JApplicationHelper|_checkPath","JComponentHelper|isEnabled","JController|\$_acoSection","JController|\$_acoSectionValue",
"JController|authorize","JController|setAccessControl","JControllerLegacy|display","JArchiveBzip2","JArchiveGzip2","JArchiveTar","JArchiveZip","JObject|toString",
"JClientLdap","JDatabase","JDatabaseDriver|connected","JDatabase|hasQuoted","JDatabase|quoted","JDatabase|addQuoted","JDatabase|hasUTF","JDatabase|debug",
"JDatabase|explain","JDatabase|getEscaped","JDatabase|getTableFields","JDatabase|getTicker","JDatabase|isQuoted","JDatabase|loadResultArray","JDatabase|nameQuote",
"JDatabase|queryBatch","JDocument|setMetaData","JDocumentRenderer","JDocumentFeed","JDocumentOpenSearch","JDocumentXml|\$_name","JBrowser","JBrowser|setQuirk","JBrowser|hasQuirk","JBrowser|getQuirk","JBrowser|setFeature","JBrowser|hasFeature","JBrowser|getFeature","JBrowser|\$_majorVersion",
"JBrowser|\$_browser","JBrowser|\$_agent","JBrowser|\$_lowerAgent","JBrowser|\$_accept","JBrowser|\$_accept_parsed","JBrowser|\$_platform","JBrowser|\$_robots",
"JBrowser|\$_mobile","JBrowser|\$_images","JRequest|clean","JRequest|_cleanVar","JURI","JURI|\$_uri","JURI|\$_scheme","JURI|\$_host","JURI|\$_port","JURI|\$_user",
"JURI|\$_pass","JURI|\$_path","JURI|\$_pass","JURI|\$_query","JURI|\$_fragment","JURI|\$_vars","JError","JProfiler","JStream|\$_fh","JStream|\$_filesize","JStream|\$_content","JStream|\$_openmode",
"JStreamString|\$_currentstring","JStreamString|\$_path","JStreamString|\$_mode","JStreamString|\$_options","JStreamString|\$_opened_path","JStreamString|\$_pos",
"JStreamString|\$_len","JStreamString|\$_stat","JFilterInput","JHTML","JHtmlAccess|assetgroups","JHtmlBehaviour|mootools","JHtmlBehaviour|noframes","JHtmlList|ordering","JHTMLList|users","JHtmlSelect|\$_optionDefailts",
"JToolBar","JButton","JPagination|\$_viewall","JPagination|\$_additionalUrlParams","JInstaller|getOverwrite","JInstaller|getUpgrade","JInstaller|\$_paths","JInstaller|\$_upgrade","JInstaller|\$_overwrite","JInstaller|\$_stepStack",
"JInstallerLanguage|\$_core","JLanguage|getPluralSufficesCallback","JLanguage|_parseLanguageFiles","JLanguage|_parseXMLLanguageFiles","JLanguage|_parseXMLLanguageFile","JLanguage|loadLanguage","JRegistry|loadXML","JRegistry|loadINI","JRegistry|loadJSON","JRegistry|makeNameSpace","JRegistry|getNameSpaces","JRegistry|getValue","JRegistry|setValue","JRegistry|loadSetupFile",
"JRegistryFormatINI|stringToObject","JRegistryFormatJSON|stringToObject","JSessionStorageDatabase|\$_data","JTable|getInstance","JTable|canDelete","JTable|toXML","JUpdate|\$_xml_parser","JUpdate|\$_stack","JUpdate|\$_state_store","JUpdate|\$_current_update",
"JUpdater|arrayUnique","JAUTHENTICATE_STATUS_","JAuthentication|\$_observers","JAuthentication|\$_state","JAuthentication|\$_methods","JUser|getParameters","JUser|authorisedlevels","JUser|authorize","JUser|\$usertype",
"JBuffer|\$_buffers","JDate|toMysql","JDate|toFormat","JDate|setOffset","JDate|\$offsets","JDate|__construct","JDate|\$_tz","JUtility|sendMail","JUtility|sendAdminMail","JUtility|getHash","JUtility|getToken","JUtility:isWinOS","JUtility|dump","JUtility|array_unshift_ref",
"JXMLElement|data","JXMLElement|getAttribute");



/** The checking function
* 
* Enclosed in a function so recursion is easier to implement
*
* @arg dir - relative path to the directory to check
*
*/
function checkCurrDir($dir){
$fh = scandir($dir);

global $strings;




foreach ($fh as $cdir){

  if ($cdir != '.' && $cdir  != '..'){
    if (!is_dir($dir."/".$cdir)){
    // Not a directory, check the file, if it's a PHP file
	
	$ext = substr(strrchr($cdir,'.'),1);
	// Check it's a PHP file, and prevent checking of self
	if (($cdir != "J3_Compat.php") && ($ext == 'php' || $ext == 'PHP')){ 

	$filecontents = file_get_contents($dir."/".$cdir,true);
	


	foreach ($strings as $str){


		if (substr_count($str,"|") > 0){
		// We need to check for class as well. Replace $'s with a blank as we won't have included that if checking value of an objects variable
		  $string = explode("|",$str);
		  if ((substr_count($filecontents,$string[0]) > 0) && (substr_count($filecontents,str_replace("\$","",$string[1])))){
		  echo "$dir/$cdir may need checking as it appears to contain {$string[0]}::{$string[1]} (though the ".
		  "class may have been assigned to an object)<br/>\n";
		  }

		}else{
		$exists = substr_count($filecontents, $str);
		  if ($exists > 0){
		  echo "$dir/$cdir may need checking as it contains '$str'<br/>\n";
		  }
	    }
	  }



      // Perform a check for JFolder and JFile and insure that the relevant JImport is in place

	    if ((substr_count($filecontents, "JFolder") > 0) && substr_count($filecontents, "joomla.filesystem.folder")){
	    echo "$dir/$cdir may need checking as it contains 'JFolder' but doesn't appear to contain an appropriate jimport<br/>\n";
	    }

	    if ((substr_count($filecontents, "JFile") > 0) && substr_count($filecontents, "joomla.filesystem.file")){
	    echo "$dir/$cdir may need checking as it contains 'JFile' but doesn't appear to contain an appropriate jimport<br/>\n";
	    }


	  if ((substr_count($filecontents, "JUtility") > 0) && substr_count($filecontents, "joomla.utilities.utility")){
	    echo "$dir/$cdir may need checking as it contains 'JFile' but doesn't appear to contain an appropriate jimport<br/>\n";
	    }


      }else{

      // Check whether it's XML (if so we can check that <install> hasn't been used amongst other things

	if ($ext == "xml" || $ext == "XML"){
	$filecontent = file_get_contents($dir."/".$cdir,true);

	  if (substr_count($filecontent,"<install>") > 0){
	  echo "$dir/$cdir may need checking as it contains an <install> tag. Should really be <extension>!<br/>\n";
	  }

	  if (substr_count($filecontent,"<install_script>") > 0){
	  echo "$dir/$cdir may need checking as it contains an <install_script> tag. Should really be <scriptfile>!<br/>\n";
	  }

	  if (substr_count($filecontent,"<uninstall_script>") > 0){
	  echo "$dir/$cdir may need checking as it contains an <uninstall_script> tag. Should really be <scriptfile>!<br/>\n";
	  }
	

	if ((substr_count($filecontent,"com_install") > 0) || ((substr_count($filecontent,"com_uninstall") > 0))){
	  echo "$dir/$cdir may need checking as it contains either com_install or com_uninstall!<br/>\n";
	  }

      }

     }

    }else{
    // is a directory, recurse into it - unless it's called .svn
    if ($cdir != ".svn"){
    checkCurrDir($dir."/".$cdir);
    }
    }

  }
}


}




// Tell the user we're starting checks and then start from the current directory
echo "Starting file checks<br/>\n";
checkCurrDir('.');
echo "\n\n <br/><br/>Finished checking, please see above for details<br/><br/>\n\n If anything was shown, you can get further details at http://docs.joomla.org/Potential_backward_compatibility_issues_in_Joomla_3.0_and_Joomla_Platform_12.1<br/>";


?> 
